
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#pragma hdrstop

#define version "1.00"

#include "mz.hpp"
#include "pe.hpp"
#include "context.hpp"
#include "disasm.hpp"
#include "lde32.hpp"
#include "global.cpp"
#include "context.cpp"
#include "peldr.cpp"
#include "disasm.cpp"

DWORD x_max;
DWORD x_alloc = 0;
BYTE** x_arr;
DWORD* x_len;
DWORD* x_count;

void x_add(BYTE* data, DWORD len)
{
  if (x_alloc == 0)
  {
    x_alloc = 65536;
    (BYTE*) x_arr   = (BYTE*) malloc(4*x_alloc);
    (DWORD*)x_len   = (DWORD*)malloc(4*x_alloc);
    (DWORD*)x_count = (DWORD*)malloc(4*x_alloc);
  }
  for (DWORD i = 0; i < x_max; i++)
  {
    if (x_len[i] == len)
    if (memcmp(x_arr[i], data, len) == 0)
    {
      x_count[i]++;
      return;
    }
  }
  if (x_max >= x_alloc)
  {
    x_alloc *= 2;
    (BYTE*) x_arr =   (BYTE*) realloc(x_arr,   4*x_alloc);
    (DWORD*)x_len =   (DWORD*)realloc(x_len,   4*x_alloc);
    (DWORD*)x_count = (DWORD*)realloc(x_count, 4*x_alloc);
  }
  x_arr[x_max] = data;
  x_len[x_max] = len;
  x_count[x_max] = 1;
  x_max++;
}

void main(int argc, char* argv[])
{
  printf("PE CODE ANALYZER   %s   (x) Z0MBiE   right toolz for the right job\n", version);

  if (argc!=2)
  {
    printf("syntax: ANALYZER <infile.EXE>\n");
    return;
  }

  load(argv[1]);
  disasm();

////////////////////////////////////////////////////////////////////////////

  printf(" analyzing instructions\n");

#define MAXN 5
  BYTE* ptr[MAXN];
  DWORD nptr = 0;

  for (DWORD n=1; n<=MAXN; n++)
  {
    x_max = 0;
    for (DWORD ip=pe->pe_imagebase; ip<pe->pe_imagebase+pe->pe_imagesize; ip++)
    {
      progress(ip);
      if (FLAG(ip) & FLAG_OPCODE)
      {
        DWORD len = disasm_main( DATAPTR(ip) );
        if ((len!=0)&&(len!=0xFFFFFFFF))
        {
          memset(DATAPTR(ip)+len-csize, 0x00, csize);
          for (DWORD j=0; j<n-1; j++)
            ptr[j] = ptr[j+1];
          ptr[n-1] = DATAPTR(ip);
          nptr++;
          if (nptr >= n)
            x_add(ptr[0], ptr[n-1]+len-ptr[0]);
          ip += len - 1;
          continue;
        }
      }
      nptr = 0;
    }
    printf("%i opcodes, %i entries\n", n, x_max);

    char s[260];
    sprintf(s,"_output%i.x1", n);
    FILE*f=fopen(s,"wb");
    assert(f);

    for (DWORD i=0; i<x_max; i++)
    if (x_count[i] >= 3)
    {
      fprintf(f,"%6i ",x_count[i],x_len[i]);
      DWORD len = 0;
      for (DWORD j=0; j<x_len[i]; j++)
      {
        if (!len)
        {
          if (j) fprintf(f," -");
          len = disasm_main(&x_arr[i][j]);
        }
        fprintf(f," %02X",x_arr[i][j]);
        len--;
      }
      fprintf(f,"\n");
    }

    fclose(f);

  }


////////////////////////////////////////////////////////////////////////////

}
