
#define SINGLE_BLOCK

#define MEM_INIT                0
#define FLAG_INIT               0
#define MEMB_OUTOFRANGE         0xFF
#define MEMW_OUTOFRANGE         0xFFFF
#define MEMD_OUTOFRANGE         0xFFFFFFFF
#define FLAG_OUTOFRANGE         0

struct memblock
{
  DWORD addr, size;
  BYTE* dataptr;
  DWORD* flagptr;
  memblock* next;
};

#ifdef SINGLE_BLOCK

#define _INDEX(x)       ((x) - mb.addr < mb.size ? (x) - mb.addr : 0)
#define DATAPTR(x)      (&mb.dataptr[_INDEX(x)])
#define MEMB(x)         (*(BYTE*)DATAPTR(x))
#define MEMW(x)         (*(WORD*)DATAPTR(x))
#define MEMD(x)         (*(DWORD*)DATAPTR(x))
#define FLAG(x)         (mb.flagptr[_INDEX(x)])
#define ALLOC(a,b)      mem_alloc(a,b)
#define LOAD(a,b,c,d)   mem_load(a,b,c,d)

#else // SINGLE_BLOCK

#define DATAPTR(x)      ctx->getdataptr(x)
#define MEMB(x)         ctx->memb[(x)]
#define MEMW(x)         ctx->memw[(x)]
#define MEMD(x)         ctx->memd[(x)]
#define FLAG(x)         ctx->flag[(x)]
#define ALLOC(a,b)      ctx->alloc(a,b)
#define LOAD(a,b,c,d)   ctx->load(a,b,c,d)

class context
{
  public:

  context();

  memblock *root, *tail, *curr;

  __property DWORD flag[DWORD] = {read=getflag,  write=setflag };

  __property BYTE  memb[DWORD] = {read=getbyte,  write=setbyte };
  __property WORD  memw[DWORD] = {read=getword,  write=setword };
  __property DWORD memd[DWORD] = {read=getdword, write=setdword};

  void   alloc(DWORD addr, DWORD size);
  void   load(DWORD addr, DWORD size, FILE* f, DWORD offs);

  memblock* getblock(DWORD addr);
  DWORD  getsize(DWORD addr);
  BYTE*  getdataptr(DWORD addr);
  DWORD* getflagptr(DWORD addr);

  DWORD  __fastcall getflag(DWORD addr);
  void   __fastcall setflag(DWORD addr, DWORD value);

  BYTE   __fastcall getbyte(DWORD addr);
  void   __fastcall setbyte(DWORD addr, BYTE value);

  WORD   __fastcall getword(DWORD addr);
  void   __fastcall setword(DWORD addr, WORD value);

  DWORD  __fastcall getdword(DWORD addr);
  void   __fastcall setdword(DWORD addr, DWORD value);

  private:
};

#endif // SINGLE_BLOCK

