
#define label_prefix "_"
#define RENUM_LABELS

#define V_ALIGN         4096
#define F_ALIGN         512

char* jxx_cond[16] =
  {"o","no","b","ae","z","nz","be","a",
   "s","ns","pe","po","l","ge","le","g"};

#ifdef RENUM_LABELS
DWORD  lbl_max = 65536;
DWORD  lbl_num = 0;
DWORD* lbl_arr = (DWORD*)malloc(4*lbl_max);
#endif // RENUM_LABELS

char lblstr[260];

char* do_label(DWORD n)
{
#ifdef RENUM_LABELS
  DWORD c = NONE;
//if (lbl_arr==NULL) lbl_arr=(DWORD*)malloc(4*lbl_max);
  for (DWORD i=0; i<lbl_num; i++)
    if (lbl_arr[i] == n)
    {
      c = i;
      break;
    }
  if (c == NONE)
  {
    if (lbl_num >= lbl_max)
    {
      lbl_max *= 2;
      lbl_arr = (DWORD*)realloc(lbl_arr, 4*lbl_max);
    }
    c = lbl_num;
    lbl_arr[lbl_num++] = n;
  }
  sprintf(lblstr, "%s%i", label_prefix, c);
#else // RENUM_LABELS
  sprintf(lblstr, "%s%X", label_prefix, n);
#endif // RENUM_LABELS
  return lblstr;
}

DWORD getsect(DWORD rva)
{
  for (DWORD i=0; i<(DWORD)pe->pe_numofobjects; i++)
    if (rva - oe[i].oe_virtrva < oe[i].oe_virtsize)
      return i;
  return 0xFFFFFFFF;
}

void dump(char* fname)
{
  printf(" writing %s\n", fname);

  FILE*f = fopen(fname, "wb");
  assert(f);

  fprintf(f,";-----------------------------------------------\n"\
            "; REVERT %s (x) Z0MBiE, http://z0mbie.cjb.net \n"\
            ";-----------------------------------------------\n\n", version);

  fprintf(f,"I_BASE  equ 0%08Xh\n", pe->pe_imagebase);
  fprintf(f,"V_ALIGN equ 0%08Xh ; %i\n", V_ALIGN, V_ALIGN);
  fprintf(f,"F_ALIGN equ 0%08Xh ; %i\n\n", F_ALIGN, F_ALIGN);

  fprintf(f,"align macro n\n"\
            "  i = $-imgbase\n"\
            "  c = ((i+n-1) and (not (n-1))) - i\n"\
            "  if c ne 0\n"\
            "    db c dup (0)\n"\
            "  endif\n"\
            "endm\n\n");

  fprintf(f,"unicode macro string\n"\
            "  irpc c, <string>\n"\
            "    t = '&c'\n"\
            "    if (t ge 0C0h)\n"\
            "      t = t - 0C0h + 410h\n"\
            "    endif\n"\
            "    dw t\n"\
            "  endm\n"\
            "endm\n\n");

  fprintf(f,"model small\n"\
            "p386\n"\
            "jumps\n"\
            "\n"\
            "code32 segment use32\n"\
            "assume cs:code32, ds:code32, es:code32, fs:code32\n\n");

  fprintf(f,"imgbase:\n\n");

  for (DWORD n1 = 0; n1 < (DWORD)pe->pe_numofobjects+1; n1++)
  {
    DWORD n=n1-1, minj, maxj;

    if (n==0xFFFFFFFF)
    {
      minj = pe->pe_imagebase;
      maxj = pe->pe_imagebase + pe->pe_headersize;
    }
    else
    {
      fprintf(f,"\n; section %X, %-8s\n\n", n, oe[n].oe_name);

      fprintf(f,"align F_ALIGN\n");
      fprintf(f,"s_%X_p_s: ; start of section (physical)\n", n);
      if (n==0)
        fprintf(f,"s_%X_v_s = ((pe_h_e-imgbase) + V_ALIGN - 1) and (not (V_ALIGN - 1)) ; start of section (virtual)\n", n);
      else
        fprintf(f,"s_%X_v_s = s_%X_v_e ; start of section (virtual)\n", n,n-1);
      fprintf(f,"cur_p_s = s_%X_p_s\n", n);
      fprintf(f,"cur_v_s = s_%X_v_s\n\n", n);

      minj = pe->pe_imagebase + oe[n].oe_virtrva;
      maxj = pe->pe_imagebase + oe[n].oe_virtrva + oe[n].oe_virtsize;
}

//  fprintf(f,"; min=%08X max=%08X\n",minj,maxj);

    int physend = 0;
    for (DWORD j = minj; j < maxj; )
    {
      progress(j);

///////////
      DWORD z = pe->pe_imagebase+mz->mz_neptr+0x18+pe->pe_ntheadersize;
      if (n==0xFFFFFFFF)
      for (DWORD n = 0; n < (DWORD)pe->pe_numofobjects; n++)
      {
  //BYTE    oe_name[8);             // 00 01 02 03  04 05 06 07
  //DWORD   oe_virtsize;            // 08 09 0A 0B
  //DWORD   oe_virtrva;             // 0C 0D 0E 0F
  //DWORD   oe_physsize;            // 10 11 12 13
  //DWORD   oe_physoffs;            // 14 15 16 17
  //BYTE    oe_reserved[0x0C);      // 18 19 1A 1B   1C 1D 1E 1F  20 21 22 23
  //DWORD   oe_objectflags;         // 24 25 26 27
        if (j == z) fprintf(f,"\n; section %X\n\n",n);

        if (j == z + 0x08)
        {
          fprintf(f,"dd s_%X_v_e-s_%X_v_s ; virtsize\n",n,n);
          fprintf(f,"dd s_%X_v_s         ; virtrva\n",n);
          fprintf(f,"dd ((s_%X_p_e-s_%X_p_s) + F_ALIGN - 1) and (not (F_ALIGN - 1)) ; physsize\n",n,n);
          fprintf(f,"dd s_%X_p_s-imgbase ; physoffs\n",n);
          j+=4*4;
          break;
        }
        else
           z += sizeof(PE_OBJENTRY);
      }// for n

  #define chkdw(x,y,z)  if ( (j==pe->pe_imagebase+(x)) ) \
                        {                              \
                          fprintf(f,y,z);              \
                          j+=2;                        \
                        }                              \
                        else
  #define chkdd(x,y,z)  if ( (j==pe->pe_imagebase+(x)) && (MEMD(j)) ) \
                        {                              \
                          fprintf(f,y,z);              \
                          j+=4;                        \
                        }                              \
                        else

      if (n==0xFFFFFFFF)
      chkdd(0x3C, "dd pe_h_s-imgbase ; PE header offset\n",0);
      chkdw(mz->mz_neptr+0x06, "dw 0%04Xh ; num of sections\n",pe->pe_numofobjects);
      chkdd(mz->mz_neptr+0x08, "dd 0 ; datetime\n",0);
      chkdd(mz->mz_neptr+0x34, "dd I_BASE  ; imagebase\n", 0);
      chkdd(mz->mz_neptr+0x38, "dd V_ALIGN ; objectalign\n",0);
      chkdd(mz->mz_neptr+0x3C, "dd V_ALIGN ; filealign\n",0);
      chkdd(mz->mz_neptr+0x50, "dd img_end ; imagesize\n",0);
      chkdd(mz->mz_neptr+0x54, "dd pe_h_e-imgbase ; headersize\n",0);
      chkdd(mz->mz_neptr+0x58, "dd 0 ; checksum\n",0);
      chkdd(mz->mz_neptr+0x7C, "dd exp_e-exp_s ; export size\n",0);
      chkdd(mz->mz_neptr+0x84, "dd imp_e-imp_s ; import size\n",0);
      chkdd(mz->mz_neptr+0x8C, "dd res_e-res_s ; resource size\n",0);
      chkdd(mz->mz_neptr+0xC4, "dd tls_e-tls_s ; tls size\n",0);
      chkdd(mz->mz_neptr+0xDC, "dd iat_e-iat_s ; iat size\n",0);
      {
      }
////////

      char* xname = 0;
#define chkxx(x,y)  if ( (j==pe->pe_imagebase+(x)) && (MEMD(j)) ) xname = y;
      chkxx(mz->mz_neptr+0x78, "exp_s");
      chkxx(mz->mz_neptr+0x80, "imp_s");
      chkxx(mz->mz_neptr+0x88, "res_s");
      chkxx(mz->mz_neptr+0xC0, "tls_s");
      chkxx(mz->mz_neptr+0xD8, "iat_s");
      chkxx(mz->mz_neptr+0x28, "start");

#define chk(x,y)  if (x!=0) if (j==pe->pe_imagebase+(x)) fprintf(f,y);
      chk(mz->mz_neptr, "\npe_h_s: ; PE header\n\n");

      chk(pe->pe_entrypointrva,"start: ; entry point\n\n");
      chk(pe->pe_importrva,"imp_s: ; import start\n\n");
      chk(pe->pe_importrva+pe->pe_importsize,"imp_e: ; import end\n\n");
      chk(pe->pe_exportrva,"exp_s: ; export start\n\n");
      chk(pe->pe_exportrva+pe->pe_exportsize,"exp_e: ; export end\n\n");
      chk(pe->pe_resourcerva,"res_s: ; resource start\n\n");
      chk(pe->pe_resourcerva+pe->pe_resourcesize,"res_e: ; resource end\n\n");
      chk(pe->pe_tlsrva,"tls_s: ; tls start\n\n");
      chk(pe->pe_tlsrva+pe->pe_tlssize,"tls_e: ; tls end\n\n");
      chk(pe->pe_iatrva,"iat_s: ; iat start\n\n");
      chk(pe->pe_iatrva+pe->pe_iatsize,"iat_e: ; iat end\n\n");

      if (!(FLAG(j) & FLAG_PRESENT))
      if (!physend)
      {
        fprintf(f,"\ns_%X_p_e: ; end of section (physical)\n\n", n);
        physend++;
      }

      if (FLAG(j) & FLAG_EXPORT) fprintf(f,"; EXPORT\n");
//    if (FLAG(j) & FLAG_IMPORT) fprintf(f,"; IMPORT\n");

      if (FLAG(j) & FLAG_LABEL)  fprintf(f,"%s:", do_label(j-pe->pe_imagebase) );
      if (FLAG(j) & FLAG_CREF)   fprintf(f," ; CREF");
      if (FLAG(j) & FLAG_DREF)   fprintf(f," ; DREF");
      if (FLAG(j) & FLAG_LABEL)  fprintf(f,"\n");

//    fprintf(f,"%08X: ", j);

      if (FLAG(j) & FLAG_RES)
      {
        if (FLAG(j) & FLAG_RES8)
          fprintf(f,"\tdd %s - res_s + 80000000h\n", do_label( (MEMD(j) & 0x7FFFFFFF) + pe->pe_resourcerva ) );
        else
          fprintf(f,"\tdd %s - res_s\n", do_label( MEMD(j) + pe->pe_resourcerva ) );
        j += 4;
      }
      else
      if ( (FLAG(j) & FLAG_RVA) &&  MEMD(j) )
      {
        DWORD s = getsect(MEMD(j));
        if (xname==0) xname=do_label(MEMD(j));
        if (s==n)
          fprintf(f,"\tdd cur_v_s + (%s - cur_p_s) ; rva\n", xname);
        else
          fprintf(f,"\tdd s_%X_v_s + (%s - s_%X_p_s) ; rva\n", s, xname, s);
        j += 4;
      }
      else
      if (FLAG(j) & FLAG_FIXUP)
      {
        DWORD s = getsect(MEMD(j)-pe->pe_imagebase);
        if (s==n)
          fprintf(f,"\tdd cur_v_s + (%s - cur_p_s) + I_BASE ; fixup\n", do_label( MEMD(j)-pe->pe_imagebase ));
        else
          fprintf(f,"\tdd s_%X_v_s + (%s - s_%X_p_s) + I_BASE ; fixup\n", s, do_label( MEMD(j)-pe->pe_imagebase ), s);
        j += 4;
      }
      else
      if (FLAG(j) & FLAG_DD)
      {
        fprintf(f,"\tdd 0%08Xh\n", MEMD(j));
        j += 4;
      }
      else
      if (FLAG(j) & FLAG_DW)
      {
        fprintf(f,"\tdw 0%04Xh\n", MEMW(j));
        j += 2;
      }
      else
      {
        if (FLAG(j) & FLAG_PRESENT)
        {
          if (FLAG(j) & FLAG_OPCODE)
          {
            if (FLAG(j) & FLAG_HAVEREL)
            {
              DWORD rel4 = j+5+(long)MEMD(j+1)-pe->pe_imagebase;
              DWORD rel1 = j+2+(char)MEMB(j+1)-pe->pe_imagebase;
              DWORD relF = j+6+(long)MEMD(j+2)-pe->pe_imagebase;
              if ((MEMB(j)&0xF0)==0x70)
              {
                fprintf(f,"\tj%s %s ; short\n", jxx_cond[MEMB(j)&15], do_label(rel1) );
                j+=2;
              }
              else
              switch ( MEMB(j) )
              {
                case 0xE9: j+=5; fprintf(f,"\tjmp %s ; near\n",  do_label(rel4)); break;
                case 0xE8: j+=5; fprintf(f,"\tcall %s\n",        do_label(rel4)); break;
                case 0xEB: j+=2; fprintf(f,"\tjmp %s ; short\n", do_label(rel1)); break;
                case 0xE0: j+=2; fprintf(f,"\tloopnz %s\n",      do_label(rel1)); break;
                case 0xE1: j+=2; fprintf(f,"\tloopz %s\n",       do_label(rel1)); break;
                case 0xE2: j+=2; fprintf(f,"\tloop %s\n",        do_label(rel1)); break;
                case 0xE3: j+=2; fprintf(f,"\tjecxz %s\n",       do_label(rel1)); break;
                case 0x0F: if ((MEMB(j+1)&0xF0)==0x80)
                           {
                             fprintf(f,"\tj%s %s ; near\n", jxx_cond[MEMB(j+1)&15], do_label(relF) );
                             j+=6;
                           }
                           else
                             printf("{%02X}",MEMB(j+1));
                           break;
                default:   printf("{%02X}",MEMB(j));
              } //switch
            } // FLAG_HAVEREL
            else
            {
              if ( (MEMW(j)==0x25FF)&&(FLAG(j+2)&FLAG_FIXUP) )
                fprintf(f,"\t; jmp dword ptr [...]\n");
              DWORD len = disasm_main( DATAPTR(j) );
              fprintf(f,"\tdb 0%02Xh", MEMB(j)); j++;
              for (DWORD i=1; i<len; i++)
              {
                if (FLAG(j) & (FLAG_FIXUP|FLAG_LABEL)) break;
                fprintf(f,",0%02Xh", MEMB(j)); j++;
              }
              fprintf(f,"\n");
            } // FLAG_HAVEREL
          } // FLAG_OPCODE
          else
          if (FLAG(j) & FLAG_CODE)
          {
            fprintf(f,"\tdb 0%02Xh\n", MEMB(j)); j++;
          }
          else
          {

#define ascii(x)        ((((x)>=32)&&((x)<128))||((x)==13)||((x)==10))

#define unicode(x)   ( ( (((x)&0xFF00)==0x0000)&&((x)>=32)&&((x)<128)&&((x)!='%')&&((x)!=',')&&((x)!='\x27')&&((x)!='<')&&((x)!='>') ) || \
                       ( (((x)&0xFF00)==0x0400)&&(((x)&0xFF)>=0x10)&&(((x)&0xFF)<0x50) ) )

char* unicode_chr = "";

            DWORD c = 1, q;

            if (ascii(MEMB(j)))
            {
              q = 1;
              while ( (FLAG(j+c) == FLAG_PRESENT) &&
                      ascii( MEMB(j+c) ) &&
                      (j+c < maxj)
                    ) c++;
              if (FLAG(j+c) == FLAG_PRESENT)
              if (MEMB(j+c) == 0)
                c++;
            }

            if (c<=2)
            if (unicode(MEMW(j)))
            {
              c = q = 2;
              while ( (FLAG(j+c) == FLAG_PRESENT) &&
                      unicode( MEMW(j+c) ) &&
                      (j+c < maxj)
                    ) c += 2;
            }

            if (c >= (FLAG(j) & FLAG_DREF ? (2*q) : (5*q)))
            {
              if (q==1)
              {

                fprintf(f,"db ");
                int m = -1, l=3;
                while (c--)
                {
                  if (l>=64)
                  {
                    if (m==1) fprintf(f,"'");
                    fprintf(f,"\ndb "); l=3;
                    m=-1;
                  }
                  if ((MEMB(j)<32)||(MEMB(j)==0x27))
                  {
                    if (m==1) { fprintf(f,"'"); l++; };
                    if (m!=-1) { fprintf(f,","); l++; };
                    fprintf(f,"%i", MEMB(j)); l+=3;
                    if ((MEMB(j)==10)&&(MEMB(j+1)!=10)&&(MEMB(j+1)!=0)) l+=64;
                    j++;
                    m=0;
                  }
                  else
                  {
                    if (m!=1)
                    {
                      if (m!=-1) { fprintf(f,","); l++; };
                      fprintf(f,"'"); m=1; l++;
                    };
                    fprintf(f,"%c", MEMB(j)); l++; j++;
                  }
                }
                if (m==1) fprintf(f,"'");
                fprintf(f,"\n");

              } //q==1
              else
              {
                fprintf(f,"unicode <");
                DWORD l=9;
                while (c)
                {
                  if (l>=64)
                  {
                    fprintf(f,">\nunicode <");
                    l=9;
                  }
                  DWORD t = MEMW(j);
                  if (t & 0xFF00)
                    t = unicode_chr[ t-0x410 ];
                  fprintf(f,"%c",t); l++;
                  j+=2;
                  c-=2;
                }
                fprintf(f,">\n");
              } //q==2

            }
            else
            {
              c = 1;
              while ( ((FLAG(j+c) & (~FLAG_PRESENT)) == 0) &&
                      (MEMB(j+c) == MEMB(j)) &&
                      (j+c < maxj)
                    ) c++;
              if (c<8) c=1;
              if (c==1)
              {
                fprintf(f,"db 0%02Xh ;", MEMB(j));
              }
              else
              {
                if (j+c>=maxj) break; // skip alignment's 0's
                fprintf(f,"db 0%04Xh dup (0%02Xh) ;", c, MEMB(j));
              }
              if (MEMB(j)>32)
                fprintf(f," '%c'", MEMB(j));
              fprintf(f,"\n");
              j += c;

            }
          }
        } // FLAG_PRESENT
        else
        {
          DWORD c = 1;
          while ( (FLAG(j+c) == 0) && (j+c < maxj) ) c++;
          if (c == 1)
            fprintf(f,"db ?\n");
          else
          {
            if (j+c>=maxj) break; // skip alignment's ?'s
            fprintf(f,"db 0%04Xh dup (?)\n", c);
          }
          j += c;
        }
      }
    } // for  j

    fprintf(f,"\n");
    if (n==0xFFFFFFFF)
    {
      fprintf(f,"pe_h_e: ; end of headers\n\n");
    }
    else
    {
      if (!physend)
        fprintf(f,"s_%X_p_e: ; end of section (physical)\n", n);
      fprintf(f,"s_%X_v_e = s_%X_v_s + (($ - s_%X_p_s) + V_ALIGN - 1) and (not (V_ALIGN - 1)) ; end of section (virtual)\n", n,n,n,n);
      if (physend)
        fprintf(f,"org s_%X_p_e ; skip uninit data\n", n);
    }
  }

  fprintf(f,"\nimg_end = s_%X_v_e ; end of image\n\n", pe->pe_numofobjects - 1);

  fprintf(f,"ends\n");
  fprintf(f,"end imgbase\n\n");
  fclose(f);
}
